/// <reference types="react" />
import type { Page } from '@getshogun/storefront-types';
export declare type PageComponent = React.FunctionComponent<{}>;
export declare type HUBJSONPResult = [string, () => {
    default: PageComponent;
}];
export declare type PageData = Pick<Page, 'id' | 'path'> & {
    alternatePaths: string[];
};
export interface PageModule {
    component: PageComponent;
    data: PageData;
}
export interface PageModuleLoadError {
    error: Error;
}
export declare type PageModuleLoadResult = PageModule | PageModuleLoadError;
export declare function isPageLoadError(arg: PageModuleLoadResult): arg is PageModuleLoadError;
