var __awaiter=this&&this.__awaiter||function(e,t,a,n){return new(a||(a=Promise))(function(o,i){function r(e){try{s(n.next(e))}catch(t){i(t)}}function c(e){try{s(n.throw(e))}catch(t){i(t)}}function s(e){var t;e.done?o(e.value):((t=e.value)instanceof a?t:new a(function(e){e(t)})).then(r,c)}s((n=n.apply(e,t||[])).next())})};import{BuildError as e,logger as t}from"@getshogun/storefront-logger";import{realfs as a}from"../lib/realfs";export const sharedCheckoutPath="/shogun-shared-checkout";export function generateSharedCheckoutPage({site:n,destinationPath:o,fs:i=a}){return __awaiter(this,void 0,void 0,function*(){if(!n.sharedCheckoutDomains||n.sharedCheckoutDomains&&0===n.sharedCheckoutDomains.length)return t.debug("No shared checkout domains found.");t.debug(`Shared checkout domains found. Generating ${sharedCheckoutPath} page.`);try{yield i.outputFile(o,sharedCheckoutTemplate(n))}catch(a){throw new e(`Error while generating ${sharedCheckoutPath} page`,a)}})}export function sharedCheckoutTemplate(e){return`<!DOCTYPE html>
  <html lang="en">
  <head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Shogun Shared Checkout</title>
  </head>
  <body>
    <script type="text/javascript">
      function setCookie(name, value) {
        document.cookie = name + "=" + value + ";" + ";Secure=true;SameSite=None"
      }

      function getCookie(cname) {
        var name = cname + "="
        var ca = document.cookie.split(';')
        for(var i = 0; i < ca.length; i++) {
          var c = ca[i]
          while (c.charAt(0) == ' ') {
            c = c.substring(1)
          }
          if (c.indexOf(name) == 0) {
            return c.substring(name.length, c.length)
          }
        }
        return ""
      }

      const sharedCheckoutDomains = ${JSON.stringify(e.sharedCheckoutDomains)}
      window.addEventListener('load', () => {
        if (window !== window.parent) {
          sharedCheckoutDomains.forEach((storeDomain) => {
            window.parent.postMessage({
              message: 'shared checkout loaded',
              domain: window.location.origin,
              cartId: getCookie('cartId-${e.id}')
            }, storeDomain)
          })
        }
      })

      window.addEventListener('message', (event) => {
        if (
          sharedCheckoutDomains.indexOf(event.origin) > -1
          && event.data.message === "save new cartId"
        ) {
          setCookie('cartId-${e.id}', event.data.cartId)
        }
      })
    </script>
  </body>
  </html>`}