"use strict";var __awaiter=this&&this.__awaiter||function(e,t,o,a){return new(o||(o=Promise))(function(r,n){function i(e){try{c(a.next(e))}catch(t){n(t)}}function s(e){try{c(a.throw(e))}catch(t){n(t)}}function c(e){var t;e.done?r(e.value):((t=e.value)instanceof o?t:new o(function(e){e(t)})).then(i,s)}c((a=a.apply(e,t||[])).next())})};Object.defineProperty(exports,"__esModule",{value:!0}),exports.sharedCheckoutTemplate=exports.generateSharedCheckoutPage=exports.sharedCheckoutPath=void 0;const storefront_logger_1=require("@getshogun/storefront-logger"),realfs_1=require("../lib/realfs");function generateSharedCheckoutPage({site:e,destinationPath:t,fs:o=realfs_1.realfs}){return __awaiter(this,void 0,void 0,function*(){if(!e.sharedCheckoutDomains||e.sharedCheckoutDomains&&0===e.sharedCheckoutDomains.length)return storefront_logger_1.logger.debug("No shared checkout domains found.");storefront_logger_1.logger.debug(`Shared checkout domains found. Generating ${exports.sharedCheckoutPath} page.`);try{yield o.outputFile(t,sharedCheckoutTemplate(e))}catch(a){throw new storefront_logger_1.BuildError(`Error while generating ${exports.sharedCheckoutPath} page`,a)}})}function sharedCheckoutTemplate(e){return`<!DOCTYPE html>
  <html lang="en">
  <head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Shogun Shared Checkout</title>
  </head>
  <body>
    <script type="text/javascript">
      function setCookie(name, value) {
        document.cookie = name + "=" + value + ";" + ";Secure=true;SameSite=None"
      }

      function getCookie(cname) {
        var name = cname + "="
        var ca = document.cookie.split(';')
        for(var i = 0; i < ca.length; i++) {
          var c = ca[i]
          while (c.charAt(0) == ' ') {
            c = c.substring(1)
          }
          if (c.indexOf(name) == 0) {
            return c.substring(name.length, c.length)
          }
        }
        return ""
      }

      const sharedCheckoutDomains = ${JSON.stringify(e.sharedCheckoutDomains)}
      window.addEventListener('load', () => {
        if (window !== window.parent) {
          sharedCheckoutDomains.forEach((storeDomain) => {
            window.parent.postMessage({
              message: 'shared checkout loaded',
              domain: window.location.origin,
              cartId: getCookie('cartId-${e.id}')
            }, storeDomain)
          })
        }
      })

      window.addEventListener('message', (event) => {
        if (
          sharedCheckoutDomains.indexOf(event.origin) > -1
          && event.data.message === "save new cartId"
        ) {
          setCookie('cartId-${e.id}', event.data.cartId)
        }
      })
    </script>
  </body>
  </html>`}exports.sharedCheckoutPath="/shogun-shared-checkout",exports.generateSharedCheckoutPage=generateSharedCheckoutPage,exports.sharedCheckoutTemplate=sharedCheckoutTemplate;