export { sortHead } from './sortHead';
export { getComponentFolder } from './getComponentFolder';
export { getFilesFromDir } from './getFilesFromDir';
/**
 * normalized page path means that it doesn't have forward slash in the beginning
 */
export declare const getPageResourceUrl: (pagePath: string, releaseVersion: string) => string;
export declare const getPageScriptUrl: (pagePath: string, releaseVersion: string) => string;
export declare const getPageStylesheetUrl: (pagePath: string, releaseVersion: string) => string;
export declare function handlePageResourceError(pagePath: string): void;
export declare function isUrlPresent(url: unknown): url is string;
