interface StylesheetLoadingStatus {
    onerror: () => void;
    onload: () => void;
}
export declare class StylesheetLoader {
    private loadingStylesheets;
    private releaseVersion;
    constructor({ releaseVersion }: {
        releaseVersion?: string;
    });
    loadStylesheet(pagePath: string): void;
    isLoading(pagePath: string): StylesheetLoadingStatus;
    registerCallbacks({ pagePath, callbacks, }: {
        pagePath: string;
        callbacks: {
            onload: () => void;
            onerror: () => void;
        };
    }): void;
}
export {};
