import { Page } from '@getshogun/storefront-types';
import { FileSystem } from '../types';
export interface AlternatePathMap {
    from: string;
    to: string;
    pagePath: string;
}
export interface GetAlternatePathMapping {
    (page: Page, alternatePath: Page['alternatePaths'][0], baseDir?: string): AlternatePathMap[];
}
export interface GenerateAlternatePathPagesOptions {
    pages: Page[];
    baseDir?: string;
    getAlternatePathMapping: GetAlternatePathMapping;
    fs?: FileSystem;
}
export declare function generateAlternatePathPages({ pages, baseDir, getAlternatePathMapping, fs, }: GenerateAlternatePathPagesOptions): Promise<void>;
